diff --git a/sources/src/main/webapp/js/components/vertexContextMenuList.js b/sources/src/main/webapp/js/components/vertexContextMenuList.js
index aadb956..309de75 100644
--- a/sources/src/main/webapp/js/components/vertexContextMenuList.js
+++ b/sources/src/main/webapp/js/components/vertexContextMenuList.js
@@ -54,7 +54,7 @@ class VertexContextMenuList {
 	 * @param {(Vertex|Group)} node Graph node to be displayed in the context menu.
 	 */
 	addNode(node) {
-		if (node instanceof Vertex && node.getGroup() !== null) {
+		if (node instanceof Vertex && node.group !== null) {
 			throw new Error('Vertex is already a member of some group.');
 		}
 
@@ -101,7 +101,7 @@ class VertexContextMenuList {
 		let group;
 		if (node instanceof Vertex) {
 			// create a new group
-			group = new Group({});
+			group = Group.create();
 			group.setExcluded(true);
 			group.addVertex(node);
 
diff --git a/sources/src/main/webapp/js/components/viewport.js b/sources/src/main/webapp/js/components/viewport.js
index 5e72855..6746c0e 100644
--- a/sources/src/main/webapp/js/components/viewport.js
+++ b/sources/src/main/webapp/js/components/viewport.js
@@ -33,50 +33,40 @@ function Viewport() {
 
 		edgeList.push(edge);
 
-		if (edge.getFrom() === null || edge.getFrom().isExcluded()) return;
-		if (edge.getTo() === null || edge.getTo().isExcluded()) return;
+		if (edge.from === null || edge.from.isExcluded) return;
+		if (edge.to === null || edge.to.isExcluded) return;
 
 		edgesContainer.appendChild(edge.render());
 	};
 
-	this.addVertex = function(vertex) {
-		if (!(vertex instanceof Vertex)) {
-			throw new TypeError(vertex.toString() + 'is not instance of Vertex');
+	this.addNode = function(node) {
+		if (!(node instanceof Node)) {
+			throw new TypeError(node.toString() + ' is not an instance of Node');
 		}
 
-		nodeList.push(vertex);
-		vertexList.push(vertex);
+		nodeList.push(node);
 
-		verticesContainer.appendChild(vertex.render());
-	};
-
-	this.removeVertex = function(vertex) {
-		if (!(vertex instanceof Vertex)) {
-			throw new TypeError(vertex.toString() + 'is not instance of Vertex');
+		if (node instanceof Vertex) {
+			vertexList.push(node);
+			verticesContainer.appendChild(node.render());
+		} else if (node instanceof Group) {
+			groupList.push(node);
+			groupsContainer.appendChild(node.render());
 		}
-
-		nodeList.splice(nodeList.indexOf(vertex), 1);
-		vertexList.splice(vertexList.indexOf(vertex), 1);
 	};
 
-	this.addGroup = function(group) {
-		if (!(group instanceof Group)) {
-			throw new TypeError(group.toString() + 'is not instance of Group');
+	this.removeNode = function(node) {
+		if (!(node instanceof Node)) {
+			throw new TypeError(node.toString() + ' is not an instance of Node');
 		}
 
-		nodeList.push(group);
-		groupList.push(group);
-
-		groupsContainer.appendChild(group.render());
-	};
+		nodeList.splice(nodeList.indexOf(node), 1);
 
-	this.removeGroup = function(group) {
-		if (!(group instanceof Group)) {
-			throw new TypeError(group.toString() + 'is not instance of Group');
+		if (node instanceof Vertex) {
+			vertexList.splice(vertexList.indexOf(node), 1);
+		} else if (node instanceof Group) {
+			groupList.splice(groupList.indexOf(node), 1);
 		}
-
-		nodeList.splice(nodeList.indexOf(group), 1);
-		groupList.splice(groupList.indexOf(group), 1);
 	};
 	
 	this.getEdgeList = function() {
@@ -96,11 +86,10 @@ function Viewport() {
 	};
 
 	this.addSvgDefinition = function(id, svgString) {
-		var g = DOM.createSvgElement('g', {
-			'id': id,
-		});
-		g.innerHTML = svgString;
-		definitions.appendChild(g);
+		definitions.appendChild(DOM.s('g', {
+			id,
+			innerHTML: svgString,
+		}));
 	};
 
 	this.getSize = function() {
@@ -128,7 +117,7 @@ function Viewport() {
 
 		var nodeList = app.viewportComponent.getNodeList();
 		nodeList.forEach(function(node) {
-			var center = node.getCenter();
+			var center = node.center;
 
 			sumOfCenters.x += center.x;
 			sumOfCenters.y += center.y;
@@ -186,7 +175,7 @@ function Viewport() {
 		mainSvg.appendChild(definitions);
 
 		var linearGradient = DOM.createSvgElement('linearGradient', {
-			'id': 'node--highlighted-required-provided',
+			'id': 'node--highlighted-as-required-provided',
 		});
 		linearGradient.appendChild(DOM.createSvgElement('stop', {
 			'offset': '0%',
diff --git a/sources/src/main/webapp/js/services/forceDirected.js b/sources/src/main/webapp/js/services/forceDirected.js
index 0d2499e..94e6e73 100644
--- a/sources/src/main/webapp/js/services/forceDirected.js
+++ b/sources/src/main/webapp/js/services/forceDirected.js
@@ -66,11 +66,12 @@ function ForceDirected() {
 		for (i = 0; i < visibleNodes.length; i++){
 			var currNode = visibleNodes[i];
 
-			for (j = 0; j < currNode.getInEdgeList().length; j++) {
-				var otherNode = currNode.getInEdgeList()[j].getFrom();
+			let inEdgeList = currNode.inEdgeList;
+			for (let j = 0; j < inEdgeList.length; j++) {
+				let otherNode = inEdgeList[j].from;
 
-				var currPosition = currNode.getPosition();
-				var otherPosition = otherNode.getPosition();
+				var currPosition = currNode.position;
+				var otherPosition = otherNode.position;
 
 				// calculate force
 				var x = currPosition.x - otherPosition.x;
@@ -83,11 +84,12 @@ function ForceDirected() {
 				forceField[Utils.getUniqueId(currNode)][1] += Math.round(-1 * y * (distance / attractiveStrength));
 			}
 
-			for (j = 0; j < currNode.getOutEdgeList().length; j++) {
-				var otherNode = currNode.getOutEdgeList()[j].getTo();
+			let outEdgeList = currNode.outEdgeList;
+			for (let j = 0; j < outEdgeList.length; j++) {
+				let otherNode = outEdgeList[j].to;
 
-				var currPosition = currNode.getPosition();
-				var otherPosition = otherNode.getPosition();
+				var currPosition = currNode.position;
+				var otherPosition = otherNode.position;
 
 				// calculate force
 				var x = currPosition.x - otherPosition.x;
@@ -156,7 +158,7 @@ function ForceDirected() {
 					currNode.getPosition().y + forceY,
 				);
 
-				currNode.setPosition(coords);
+				currNode.position = coords;
 				currNode.move(coords);
 			}
 		}
diff --git a/sources/src/main/webapp/js/services/graphExporter.js b/sources/src/main/webapp/js/services/graphExporter.js
index bb0a3ae..3b58e5d 100644
--- a/sources/src/main/webapp/js/services/graphExporter.js
+++ b/sources/src/main/webapp/js/services/graphExporter.js
@@ -27,20 +27,12 @@ function GraphExporter() {
 		var sideBar = excludedNodeList.map(function(node) {
 			return {
 				id: Utils.getUniqueId(node),
-                isIconsDisplayed: node.isIconsDisplayed(),
+				isIconsDisplayed: node.isIconsDisplayed,
 			};
 		});
 
-        var highlightedEdge = app.edgeList.find(function (edge) {
-            return edge.isHighlighted()
-        });
-
-        // when edge is highlighted another vertex can not be highlighted
-        if (Utils.isUndefined(highlightedEdge)) {
-            var highlightedVertex = app.nodeList.find(function (vertex) {
-                return vertex.isHighlighted()
-            });
-        }
+		let highlightedEdge = app.edgeList.find(edge => edge.isHighlighted);
+		let highlightedVertex = app.nodeList.find(vertex => vertex.isHighlighted);
 
 		return {
 			attributeTypes: app.attributeTypeList,
@@ -51,7 +43,7 @@ function GraphExporter() {
 			possibleEnumValues: app.possibleEnumValues,
 			groups: groups,
 			sideBar: sideBar,
-            highlightedVertex: Utils.getUniqueId(highlightedVertex),
+			highlightedVertex: Utils.isUndefined(highlightedVertex) ? '' : Utils.getUniqueId(highlightedVertex),
 			highlightedEdge: Utils.isUndefined(highlightedEdge) ? '' : highlightedEdge.id,
 		};
 	}
diff --git a/sources/src/main/webapp/js/services/graphLoader.js b/sources/src/main/webapp/js/services/graphLoader.js
index cef32be..37e2688 100644
--- a/sources/src/main/webapp/js/services/graphLoader.js
+++ b/sources/src/main/webapp/js/services/graphLoader.js
@@ -28,23 +28,23 @@ function GraphLoader() {
 			app.viewportComponent.addSvgDefinition('vertexArchetypeIcon-' + vertexArchetype.name, vertexArchetype.icon);
 		});
 
-        var highlightedNodeId;
-        var highlightedNodeType;
-        if (Utils.isDefined(data.highlightedVertex) && data.highlightedVertex.length > 0) {
-            var highlightedNodeAttr = data.highlightedVertex.split("-");
-            if (highlightedNodeAttr.length === 2) {
-                highlightedNodeType = highlightedNodeAttr[0];
-                highlightedNodeId = parseInt(highlightedNodeAttr[1], 10);
-            }
-        }
-        if (Utils.isDefined(data.highlightedEdge) && data.highlightedEdge.length > 0) {
-            var highlightedEdgeId = parseInt(data.highlightedEdge, 10);
-        }
+		var highlightedNodeId;
+		var highlightedNodeType;
+		if (Utils.isDefined(data.highlightedVertex) && data.highlightedVertex.length > 0) {
+			var highlightedNodeAttr = data.highlightedVertex.split("-");
+			if (highlightedNodeAttr.length === 2) {
+				highlightedNodeType = highlightedNodeAttr[0];
+				highlightedNodeId = parseInt(highlightedNodeAttr[1], 10);
+			}
+		}
+		if (Utils.isDefined(data.highlightedEdge) && data.highlightedEdge.length > 0) {
+			var highlightedEdgeId = parseInt(data.highlightedEdge, 10);
+		}
 
-        var highlightedNode = undefined;
-        var highlightedEdge = undefined;
+		var highlightedNode = undefined;
+		var highlightedEdge = undefined;
 
-        // construct vertices
+		// construct vertices
 		var vertexMap = {};
 		data.vertices.forEach(function(component) {
 			var vertex = new Vertex(component);
@@ -56,14 +56,14 @@ function GraphLoader() {
 			var position = component.position;
 
 			if (position === null || Utils.isUndefined(position)) {
-                // set random
-                vertex.setPosition(new Coordinates(
-                    Math.floor(Math.random() * canvasSize),
-                    Math.floor(Math.random() * canvasSize),
-                ));
-
-            } else {
-                vertex.setPosition(new Coordinates(position.x, position.y));
+				// set random
+				vertex.position = new Coordinates(
+					Math.floor(Math.random() * canvasSize),
+					Math.floor(Math.random() * canvasSize),
+				);
+
+			} else {
+				vertex.position = new Coordinates(position.x, position.y);
 			}
 
 			app.nodeList.push(vertex);
@@ -111,7 +111,7 @@ function GraphLoader() {
 
 		// find unconnected vertices
 		app.vertexList.filter(function(vertex) {
-			return vertex.isUnconnected();
+			return vertex.isUnconnected;
 		}).forEach(function(vertex) {
 			vertex.exclude();
 			app.sidebarComponent.unconnectedNodeListComponent.add(vertex);
@@ -128,15 +128,15 @@ function GraphLoader() {
 			// position
 			var position = component.position;
 			if (position === null || Utils.isUndefined(position)) {
-                // set random
-                group.setPosition(new Coordinates(
-                    Math.floor(Math.random() * canvasSize),
-                    Math.floor(Math.random() * canvasSize),
-                ));
-
-            } else {
-                group.setPosition(new Coordinates(position.x, position.y));
-            }
+				// set random
+				group.position = new Coordinates(
+					Math.floor(Math.random() * canvasSize),
+					Math.floor(Math.random() * canvasSize),
+				);
+
+			} else {
+				group.position = new Coordinates(position.x, position.y);
+			}
 
 			// vertices
 			app.vertexList.filter(function(vertex) {
@@ -148,7 +148,7 @@ function GraphLoader() {
 			app.nodeList.push(group);
 			app.groupList.push(group);
 
-			app.viewportComponent.addGroup(group);
+			app.viewportComponent.addNode(group);
 		});
 
 		// exclude nodes
@@ -173,7 +173,7 @@ function GraphLoader() {
 			});
 
 			if (Utils.isDefined(node)) {
-				node.exclude(excludedNode.isIconsDisplayed);
+				node.exclude();
 
 				app.sidebarComponent.excludedNodeListComponent.add(node);
 			}
@@ -186,11 +186,14 @@ function GraphLoader() {
 		app.sidebarComponent.statusBarComponent.componentCount = data.vertices.length;
 
 		if (Utils.isDefined(highlightedEdge)) {
-            highlightedEdge.setHighlighted(true);
-            highlightedEdge.getFrom().setHighlighted(true);
-            highlightedEdge.getTo().setHighlighted(true);
-        }
-		if (Utils.isDefined(highlightedNode)) highlightedNode.setHighlightedWithNeighbours(true);
+			highlightedEdge.isHighlighted = true;
+			highlightedEdge.from.isHighlighted = true;
+			highlightedEdge.to.isHighlighted = true;
+		}
+
+		if (Utils.isDefined(highlightedNode)) {
+			highlightedNode.highlightWithNeighbours(true);
+		}
 	};
 
 }
\ No newline at end of file
diff --git a/sources/src/main/webapp/showGraph.jsp b/sources/src/main/webapp/showGraph.jsp
index fb85492..59076b5 100644
--- a/sources/src/main/webapp/showGraph.jsp
+++ b/sources/src/main/webapp/showGraph.jsp
@@ -37,6 +37,7 @@
 		<script src="js/components/generic/modalWindow.js"></script>
 		<script src="js/components/generic/popover.js"></script>
 		<script src="js/components/generic/popup.js"></script>
+		<script src="js/components/node.js"></script>
 		<script src="js/components/attribute.js"></script>
 		<script src="js/components/edge.js"></script>
 		<script src="js/components/edgePopover.js"></script>
@@ -47,6 +48,7 @@
 		<script src="js/components/loginPopup.js"></script>
 		<script src="js/components/minimap.js"></script>
 		<script src="js/components/navbar.js"></script>
+		<script src="js/components/nodeSymbolList.js"></script>
 		<script src="js/components/registerPopup.js"></script>
 		<script src="js/components/saveDiagramModalWindow.js"></script>
 		<script src="js/components/sidebar.js"></script>
@@ -57,7 +59,6 @@
 		<script src="js/components/vertex.js"></script>
 		<script src="js/components/vertexContextMenuList.js"></script>
 		<script src="js/components/vertexPopover.js"></script>
-		<script src="js/components/vertexSymbolList.js"></script>
 		<script src="js/components/viewport.js"></script>
 
 		<script src="js/errors/httpError.js"></script>
